//  tst_Scale.c




#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "ut_gtk.h"
#include "../gr/ut_UI.h"



// prototypes:
  int UI_CB     (GtkWidget *parent, void *data);

// global
  static GtkObject     *adj1;
  static GtkWidget     *wsc1;



//================================================================
  int fCB1 (GtkWidget *parent, void *data) {
//================================================================

  printf("fCB1 \n");

  // // get Value of Slider
  // printf(" 1-adj=%f\n",adj1->value);

  gtk_adjustment_set_value  ((GtkAdjustment*)adj1, 25.);

/*
  // change Position of Slider
  adj1->value = 25.;
  // update
  gtk_adjustment_value_changed (adj1);


  // get Value of Slider
  printf(" 2-adj=%f\n",adj1->value);
*/

  return 0;

}


//================================================================
  int fCB2 (GtkAdjustment *adj, void *data) {
//================================================================

  // get Value of Slider
  // printf(" fCB2=%f\n",adj->value);

  printf(" fCB2=%f\n",gtk_adjustment_get_value  ((GtkAdjustment*)adj1));

  return 0;

}


//================================================================
  int main (int argc, char *argv[]) {
//================================================================


  GtkWidget *window, *box1, *wb1;

  GtkWidget     *wsc1;


  // gtk_set_locale ();
  gtk_disable_setlocale ();  // sonst Beistrich statt Decimalpunkt !! (LC_ALL)
  gtk_init (&argc, &argv);
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (window, 400, 100);
  gtk_signal_connect (GTK_OBJECT(window), "destroy",
                     (GtkSignalFunc)gtk_exit, NULL);
  // gtk_quit_add_destroy(1, GTK_OBJECT(window));


  //----------------------------------------------------------------
  box1 = gtk_vbox_new (FALSE, 1);
  gtk_container_add (GTK_CONTAINER (window), box1); 
  gtk_widget_show (box1);


  //----------------------------------------------------------------
  // Adjustment (StartVal minVal maxVal incr pageIncr pageSize)
  adj1 = gtk_adjustment_new (50., 0., 100., 0.1, 0., 0.);

  // callback for moving the control
  gtk_signal_connect (GTK_OBJECT(adj1), "value_changed",
                     GTK_SIGNAL_FUNC(fCB2), NULL);
                     // (GtkSignalFunc)gtk_exit, NULL);

  wsc1 = gtk_hscale_new (GTK_ADJUSTMENT(adj1));

  // do not display actual value
  gtk_scale_set_draw_value (GTK_SCALE(wsc1), FALSE);

  gtk_container_add (GTK_CONTAINER (box1), wsc1); 
  // gtk_box_pack_start (GTK_BOX (box1), wsc1, FALSE, FALSE, 0);

  gtk_widget_show (wsc1);


  //----------------------------------------------------------------
  // Testbutton
  wb1 = gtk_button_new_with_label ("Test");
  gtk_signal_connect (GTK_OBJECT(wb1),"clicked",(GtkSignalFunc)fCB1,NULL);
  gtk_container_add (GTK_CONTAINER (box1), wb1); 
  gtk_widget_show (wb1);


  //----------------------------------------------------------------
  gtk_widget_show (window);
  gtk_main ();

  return 0;
}


// EOF
