/* Testfunktionen fuer das Textausgabewin  (ut_gtk2Tx.c)


Linken:
make -f tst_Tx1.mak && ./tst_Tx1.exe


*/


#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include "ut_gtk.h"
#include "ut_gtkTx.h"
//#include "ut_gtkEd.h"


const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c


#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];





#define UI_FuncInit       90
#define UI_FuncKill       99







//============ Lokale Var: =======================================
  char      fnam[128];

  GtkWidget *winTX;   // das Editornenster
  GtkWidget *wText;   // das Textwidget (linkes Fenster)
  GtkWidget *gWin;    // dasrechte Win.



  int UI_open (GtkWidget *parent, void *data);






/*===================================================================== */
  int UI_work1 (GtkWidget *parent, void *data) {
/*===================================================================== */

static int iNr = 0;
  char  *cp1, cBuf[256];


  printf("UI_work1,  /%s/\n",(char*)data);

  cp1 = (char*)data;



  if(!strcmp(cp1, "f1")) {      // add Line
    sprintf(cBuf, "Line GUI_Tx_add %d;",++iNr);
    GUI_Tx_add (wText, cBuf);


  } else if(!strcmp(cp1, "f2")) {
    sprintf(cBuf, "Line GUI_Tx_wri %d;",++iNr);
    GUI_Tx_wri (cBuf);


  } else if(!strcmp(cp1, "f3")) {
    GUI_Tx_rmLast ();
    sprintf(cBuf, "Line GUI_Tx_wri %d;",++iNr);
    GUI_Tx_wri (cBuf);


  }



  return 0;
}





/*=============================================== */
  int UI_win_main (GtkWidget *parent, void *data) {
/*================
*/

  static GtkWidget *winID, *box0, *box1;
  
  int i1;


  /* -------------------------------------------------- */
  printf("UI_win1 %d\n",(int)data);

  i1 = (int)data;


  switch (i1) {


    /* Init Panel -------------------------- */
    case UI_FuncInit:

      /* Create Mainwindow */
      winID = GUI_Window ("Test", UI_win_main, (void*)UI_FuncKill, 0);



      /* Eine vbox bers gesamte Window */
      box0 = GUI_Vbox (winID, 10);




      // ein paar testbuttons
      box1 = GUI_Hbox (box0, 2);
      GUI_Butt (box1, "F1", UI_work1, (void*)"f1", 0);
      GUI_Tip  ("GUI_Tx_add");
      GUI_Butt (box1, "F2", UI_work1, (void*)"f2", 0);
      GUI_Tip  ("GUI_Tx_wri");
      GUI_Butt (box1, "F3", UI_work1, (void*)"f3", 0);
      GUI_Tip  ("overwrite");
      GUI_Butt (box1, "F4", UI_work1, (void*)"f4", 0);
      GUI_Tip  ("-");




      // das Textausgabefenster
      winTX = GUI_Tx_Win (&wText);

    
      gtk_widget_set_usize (winTX, 400, 100);

      // gtk_box_pack_start (GTK_BOX (box0), winTX, TRUE, TRUE, 2);
      gtk_container_add (GTK_CONTAINER (box0), winTX);
      gtk_widget_show (winTX);



      /* -------- Display Win ---------------- */
      gtk_widget_show (GTK_WIDGET(winID));
      gtk_widget_set_uposition (winID, 0, 0);


      break;




    case UI_FuncKill:
      gtk_widget_destroy (winID);
      winID = NULL;
      /* gtk_exit (1); */
      exit(0);
      break;


  }



  return 0;
}




/*================================================================*/
  int main () {
/*================
*/

  printf("+++++++++++++Start t1\n");

  /* Read Colours und Fonts */
  /* GUI_Init ("gcad.rc"); */
  GUI_Init ("");

  /* Init Win */
  UI_win_main (NULL, (void*)UI_FuncInit);

  /* Enter gtk-Mainloop */
  gtk_main();

  return 0;

}



/* ====================== EOF =========================== */
