/* 
 */




#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#include <windows.h>
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>



#include <GL/gl.h>
#include <GL/glu.h>



GtkWidget  *GL_widget;



// #define mem_cbuf1_SIZ 250
// char mem_cbuf1[mem_cbuf1_SIZ];      // wird von ut_txfil.c benutzt

const double UT_VAL_MAX  =  9999999999999.999;




//================================================================
  int AP_Get_Setup (char *cbufo, char *ctyps) {
//================================================================
// here: get Z-buffersize;


  char      cbuf2[128], cbuf3[128];


  printf("AP_Get_Setup |%s|\n",ctyps);

  strcpy(cbufo, "16");

  return 0;

}





//================================================================
  gint cb_realize (GtkWidget *widget) {
//================================================================

  printf("cb_realize \n");

  UI_GR_DrawConfig (widget);

  UI_GR_DrawInit ();



      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      glOrtho(0,100, 100,0, -1,1);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();

  UI_GR_DrawExit ();

  return TRUE;
}


//================================================================
  gint cb_expose (GtkWidget *widget, GdkEventExpose *event) {
//================================================================
/* When widget is exposed it's contents are redrawn. */
  /* Draw only last expose. */


  printf("cb_expose \n");

  UI_GR_DrawInit ();

  if (event->count > 0)
    return TRUE;

      /* Draw simple triangle */
      glClearColor(0,0,0,1);
      glClear(GL_COLOR_BUFFER_BIT);
      glColor3f(1,1,1);
      glBegin(GL_TRIANGLES);
      glVertex2f(10,10);
      glVertex2f(10,90);
      glVertex2f(90,90);
      glEnd();


  UI_GR_DrawExit ();

  return TRUE;
}

//================================================================
  gint cb_config (GtkWidget *widget, GdkEventConfigure *event) {
//================================================================
/* When GL_widget size changes, viewport size is set to match the new size */
  /* OpenGL functions can be called only if make_current returns true */
  // if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))


  printf("cb_config \n");

  UI_GR_DrawInit ();

      glViewport(0,0, widget->allocation.width, widget->allocation.height);

  UI_GR_DrawExit ();

  return TRUE;
}


//================================================================
  int main(int argc, char *argv[]) {
//================================================================

  int         i1, i2;
  GtkWidget   *window;


  printf("========= test.exe ========\n");

  // initialize gtk
  gtk_init (&argc, &argv);

/*
  // Check if OpenGL is supported.
  if (gdk_gl_query() == FALSE) {
    g_print("OpenGL not supported\n");
    return 0;
  }
*/


  /* Create new top level window. */
  window = gtk_window_new( GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Simple");
  gtk_container_set_border_width(GTK_CONTAINER(window), 10);




  /* Quit form main if got delete event */
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_quit_add_destroy(1, GTK_OBJECT(window));



  UI_GR_DrawCreate ();



  gtk_widget_set_events(GTK_WIDGET(GL_widget),
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK);



  /* Connect signal handlers */
  /* Redraw image when exposed. */
  gtk_signal_connect(GTK_OBJECT(GL_widget), "expose_event",
		     GTK_SIGNAL_FUNC(cb_expose), NULL);
  /* When window is resized viewport needs to be resized also. */
  gtk_signal_connect(GTK_OBJECT(GL_widget), "configure_event",
		     GTK_SIGNAL_FUNC(cb_config), NULL);
  /* Do initialization when widget has been realized. */
  gtk_signal_connect(GTK_OBJECT(GL_widget), "realize",
		     GTK_SIGNAL_FUNC(cb_realize), NULL);

  /* set minimum size */
  gtk_widget_set_usize(GTK_WIDGET(GL_widget), 100,100);
		    
  /* put GL_widget into window and show it all */
  gtk_container_add(GTK_CONTAINER(window),GTK_WIDGET(GL_widget));
  gtk_widget_show(GTK_WIDGET(GL_widget));
  gtk_widget_show(GTK_WIDGET(window));


  printf("GL_RENDERER:    %s\n",glGetString(GL_RENDERER));
  printf("GL_VERSION:     %s\n",glGetString(GL_VERSION));
  printf("GL_EXTENSIONS:  %s\n",glGetString(GL_EXTENSIONS));

  printf("GLU_VERSION:    %s\n",gluGetString(GLU_VERSION));
  printf("GLU_EXTENSIONS: %s\n",gluGetString(GLU_EXTENSIONS));


  gtk_main();

  return 0;
}
//========= EOF ===========
