/*  tst_gtk0.c

Testprogramm fuer die gtk-Utilityfunktionen in ut_gtk.c

Compile & run:
Linux:
make -f tst_gtk0.mak && ./tst0.exe
Windows:
nmake -f tst_gtk0.nmak


-----------------------------------------------------------

*/


#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "ut_gtk.h"




const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c


// prototypes:
  int UI_CB     (GtkWidget *parent, void *data);

#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];







/*===================================================================== */
  int UI_exit (GtkWidget *parent, void *data) { 
/*===================================================================== */
// exit

  printf("UI_exit\n");

  // gtk_exit(1);

  exit(0);
  return 0;

}


/*===================================================================== */
  int UI_CB (GtkWidget *parent, void *data) {
/*=============
callback-routine of button
*/

  printf("UI_CB  /%s/\n",(char*)data);

  UI_exit (NULL, NULL);

  return 0;

}






/*=============================================== */
  int main (int argc, char *argv[]) {
/*============= */

  GtkWidget *window, *box0;

  GUI_Init ("");

  printf(" XXXXXXXXXXXXX %f\n",12.34);


  // Create Mainwindow
  window = GUI_Window ("Hallo", UI_exit, NULL, 0);


  // vertical box
  box0 = GUI_Vbox (window, 0);


  // Backgroundtext
  GUI_Label (box0, "Backgroundtext", 0);


  // button
  //GUI_Butt (box0, " C L O S E ", gtk_exit, NULL, 5);
  GUI_Butt (box0, " C L O S E ", UI_CB, (void*)"close", 5);


// 
  //===========================================================
  /* Display MainWin und enter the GTK main processing loop */
  gtk_widget_show (window);
  gtk_main ();

  return 0;
}




/* --------------- eof ------------------------- */
