/*
Linux:
make -f tst_gtk2.mak &&./tst2.exe
Windows:
nmake -f tst_gtk2.nmak

-----------------------------------------------------------

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>



#include "ut_gtk.h"
#include "../gr/ut_UI.h"




#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];

const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c



int f_menu_M20 ();
int f_menu_M21 ();
int f_check ();
int f_file ();
int file_ok_sel ();
int f_ckbutt ();
int f_GetText ();
int f_radbutt ();
  int f_CB_text (GtkWidget *parent, void *data);

int list_init ();
void list_kill ();
  // void list_sel (GtkWidget *widget, GtkList *list);
  void list_sel ();
void list_add ();
void list_del_sel ();
void list_del_all ();




static GtkWidget *entry, *txtf1, *ckb1, *filew, *bk1[4], *blst,
                 *w_list;

//===================================================
  int exit__  (void *p1, void *p2) {
//===================================================

  exit (0);

}



/*=============================================== */
  int main (int argc, char *argv[]) {
/*============= */

  GtkWidget *window, *box0, *box0_1, *box1, *box2, *box2_11, *box2_2,
            *box2_1, *w1, *menu_bar, *menu, *w_tmp;



  /* Read Colours und Fonts */
  GUI_Init ("gtk1.rc");

  /* Create Mainwindow */
  window = GUI_Window ("TW1", exit__, NULL, 0);


  /* --------- Create the boxes --------- */
  /* Eine vbox, in die oben der MenuBar kommt. */
  box0 = GUI_Vbox (window, 0);

  /* Create a menu-bar to hold the menus and add it to our main window*/
  menu_bar = GUI_MenuBar (box0);

  /* Eine hbox, in die dann nebeneinender 2 vboxen (box1 u. box2) kommen. */
  box0_1 = GUI_Hbox (box0, 0);
  box1 = GUI_Vbox (box0_1, 10);
  box2 = GUI_Vbox (box0_1, 10);

  /* Create Frame (mit Text) in box2; dahinein muss dann eine Box. */
  /* Wenn mehrere Widgets in einem frame sollen, Box notwendig. */
  box2_1 = GUI_Frame (box2, "Frame 1", 10);
  box2_11 = GUI_Vbox (box2_1, 0);

  /* Eine 2. Subbox unter box2_11 */
  box2_2 = GUI_Vbox (box2, 0);


  /* Create Menu and add it to menu-bar */
  menu = GUI_Menu (menu_bar, "Options               ", 0);
  GUI_MenuEntry (menu, "Open", f_menu_M20, (void*)1);
  GUI_MenuEntry (menu, "Save", f_menu_M20, (void*)2);
  GUI_MenuEntry (menu, "Exit", f_menu_M20, (void*)3);


  /* Create Menu and add it to menu-bar */
  menu = GUI_Menu (menu_bar, "               Help", 'r');
  GUI_MenuEntry (menu, "Help Version", f_menu_M21, (void*)1);
  GUI_MenuEntry (menu, "Help Wartung", f_menu_M21, (void*)2);



  /* --------- Create Ausgabefeld in Frame ohne Text --------- */
  w_tmp = GUI_Frame (box1, NULL, 0);
  w_tmp = GUI_Vbox (w_tmp, 0);
  txtf1 = GUI_Label (w_tmp, "Hello World", 0);



  /* -------------- ein Hintergrundbild -------------- */
  GUI_Pix (box1, "test.xpm", 10);



  /* --------- Create horizontal ruler --------- */
  GUI_Hsep (box1, 0);


  /* --------- Create checkbutton --------- */
  ckb1 = GUI_CkButt (box1, "checkbutt 1",TRUE,f_ckbutt,(void*)0,0);


  /* --------- Create entry --------- */
  entry = GUI_Entry (box1, "entry ","0,0",NULL, -100);




  /* --------- Create Buttonkette (radiobuttons) --------- */
  bk1[0] = GUI_RadButt    (box2_11, "button1",f_radbutt,(void*)0,0);
  bk1[1] = GUI_RadButtAdd (box2_11, "button2",f_radbutt,(void*)1,0);
  bk1[2] = GUI_RadButtAdd (box2_11, "button3",f_radbutt,(void*)2,0);
  bk1[3] = GUI_RadButtAdd (box2_11, "button4",f_radbutt,(void*)3,0);


  /* --------- Button --------- */
  GUI_Butt (box2_2, "Check all", f_check, NULL, 2);

  /* --------- Button fr Liste --------- */
  blst = GUI_Butt (box2_2, "Liste", list_init, NULL, 2);

  /* --------- Button fr Fileselection --------- */
  w1 = GUI_Butt (box2_2, "Select File", f_file, NULL, 2);

  /* Style ((Farben, Fonts, Pixmaps ..) zuordnen */
  gtk_widget_set_name (w1, "Style1");


  /* --------- Buttons fr Dialogfenster --------- */
  GUI_Butt (box2_2, "DialogY-Window", f_CB_text, "dialogY", 5);
  GUI_Butt (box2_2, "DialogYN-Window", f_CB_text, "dialogYN", 5);



  GUI_Butt (box2_2, "TextInputWindow", f_GetText, NULL, 5);


  /* --------- Einen Button mit Bild und Text drauf --------- */
  GUI_ButtPix (box2_2,"Hugo,\nmach was","test2.xpm",
               GUI_Dialog, (void*)"jaja, ich tu was");


  /* --------- Create normalen button --------- */
  GUI_Butt (box2_2, " C L O S E ", exit__, NULL, 5);


  /* Display MainWin und enter the GTK main processing loop */
  gtk_widget_show (window);
  gtk_widget_set_uposition (window, 0, 0);



  //GdkCursor *newcursor;
  // newcursor = gdk_cursor_new(GDK_HAND1);
  // gdk_window_set_cursor(window, newcursor);
  gdk_window_set_cursor (window->window, gdk_cursor_new (GDK_HAND1));



  gtk_main ();

  return 0;
}


/*=============================================== */
  int f_check (void) {
/*===========
*/

  static int state = 1;

  /* Auslesen des Entryfeldes entry */
  /* strcpy (txt1, gtk_entry_get_text (GTK_ENTRY (entry))); */
  printf("%s\n",gtk_entry_get_text (GTK_ENTRY (entry)));

  /* Auslesen des Checkbutton ckb1 */
  /* printf("ckb1 = %d\n", GTK_TOGGLE_BUTTON (ckb1)->active); */
  if (GTK_TOGGLE_BUTTON (ckb1)->active) {
    printf("ckb1 is pressed\n");
  } else {
    printf("ckb1 is not pressed\n");
  }



  /* Ausgabefeld - Text ndern: */
  gtk_label_set (GTK_LABEL (txtf1), gtk_entry_get_text (GTK_ENTRY (entry)));

  printf("bk1 = %d\n", GTK_TOGGLE_BUTTON (bk1[0])->active);
  printf("bk1 = %d\n", GTK_TOGGLE_BUTTON (bk1[1])->active);
  printf("bk1 = %d\n", GTK_TOGGLE_BUTTON (bk1[2])->active);
  printf("bk1 = %d\n", GTK_TOGGLE_BUTTON (bk1[3])->active);

  /* gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (bk1), FALSE); */

  if (state < 0) {
    printf("Set wieder aktiv\n");
    gtk_widget_set_sensitive (ckb1, (gint)1);
    gtk_widget_set_sensitive (blst, (gint)1);
    state = 1;
  } else {
    printf("Set inaktiv\n");
    gtk_widget_set_sensitive (ckb1, (gint)0);
    gtk_widget_set_sensitive (blst, (gint)0);
    state = -1;
  }

  /* Lscht das Widget ganz weg ! retour mit gtk_widget_show ? */
  /* gtk_widget_hide (ckb1); */

  return 0;
}



//=====================================================================
  int f_CB_int (GtkWidget *parent, void *data) {
//=====================================================================

  int idat;

  printf("f_CB_int %d\n",(int)data);

  idat = (int)data;

  switch(idat) {

    case UI_FuncOK:;

    case UI_FuncCancel:;

  }

  return 0;

}



//=====================================================================
  int f_CB_text (GtkWidget *parent, void *data) {
//=====================================================================

  char  *cp1;

  printf("f_CB_text %s\n",(char*)data);

  cp1 = (char*)data;



  //=============================================================
  if(!strcmp(cp1, "dialogY")) {
    GUI_DialogY ("Info anzeigen");


  //=============================================================
  } else if(!strcmp(cp1, "dialogYN")) {
    GUI_DialogYN ("  Datei xy speichern ?  ", f_CB_int);


  //=============================================================
  }


  return 0;

}



/*===================================================================== */
  int f_ckbutt (GtkWidget *parent, void *data) {
/*============
*/
  printf("f_ckbutt %d %d\n",(int)data,GTK_TOGGLE_BUTTON (parent)->active);

  return 0;
}



/*===================================================================== */
  int f_radbutt (GtkWidget *parent, void *data) {
/*=============
*/
  printf("f_radbutt %d %d\n",(int)data,GTK_TOGGLE_BUTTON (parent)->active);
  return 0;
}



//=================================================================
  int f_GetText_CB (GtkWidget *parent, void *data) {
//=================================================================
// the callback if OK selected.

  printf("f_GetText_CB |%s|\n",(char*)data);

  return 0;
    
}   
    


//=================================================================
  int f_GetText (GtkWidget *parent, void *data) {
//=================================================================

  int   x1, y1, x2, y2;


  printf("f_GetText\n");

  GUI_GetWinPos(&x1, &y1, parent);
  GUI_GetWidgetPos(&x2, &y2, parent);
  x1 += x2;  y1 += y2;
  GUI_SetWinpos (x1, y1);
  GUI_GetText(" Name of Program: ","Nowprog", -200, f_GetText_CB);

  return 0;

}


/*================================================================= */
  int f_file (void) {
/*=======================*/

  /* filew = GUI_File_select (file_ok_sel, NULL); */
  filew = GUI_File_select ("./", file_ok_sel);

  return 0;
}



/*================================================================= */
  int file_ok_sel (GtkWidget *w, GtkFileSelection *fs) {
/*===============
  Get the selected filename and print it to the console
*/

  /* Ins Feld entry schreiben */
  gtk_entry_set_text (GTK_ENTRY (entry),
           gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));

  g_print ("%s\n", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gtk_widget_destroy (filew);

  return 0;
}


/*================================================================= */
  int list_init (void) {
/*=============
*/

 
  int       i1;
  static GtkWidget *window;
  GtkWidget *box1;

  static char *list_items[] =
  {
    "hello",
    "world",
    "blah",
    "foo",
    "bar",
    "argh",
    "spencer",
    "is a",
    "wussy",
    "programmer",
    "\0"
  };
 
 
  /* --------------------------------------------------------- */
  window = GUI_Window ("Liste 1", NULL, NULL, 10);

  gtk_widget_set_usize (window, 200, 220);

  box1 = GUI_Vbox (window, 0);


  /* create Liste */
  w_list = GUI_List (box1, list_sel, NULL);


  /* Liste befllen */
  for (i1 = 0; i1<10; i1++) {
    if (!strcmp(list_items[i1],"\0")) break;
    GUI_List_add (w_list, list_items[i1]);
  }
  /* GUI_List_add (w_list, list_items); */


  GUI_Butt (box1, "add eins", list_add,     w_list, 0);
  GUI_Butt (box1, "del sel",  list_del_sel, w_list, 0);
  GUI_Butt (box1, "del all",  list_del_all, w_list, 0);
  GUI_Butt (box1, "close",    list_kill,    window, 0);

  gtk_widget_show (window);

  return 0;
}



/*===================================================================== */
  void list_kill (GtkWidget *widget, GtkWidget *window) {
/*==============
*/


  gtk_widget_destroy (window);

}





/*===================================================================== */
  void list_sel (GtkWidget *widget, void* data) {
/*==============
*/

  int i1;

  i1 = GUI_List_select (w_list, 0);

  printf("list1_sel %d\n",i1);

}


/*===================================================================== */
  void list_add (GtkWidget *widget,  void* data) {
/*=============
*/

  printf("add_eins\n");

  GUI_List_add (w_list, "alsdkfasldkf");

}



/*===================================================================== */
  void list_del_sel (GtkWidget *widget, void* data) {
/*=================
*/

  int i1, i2;


  printf("list_del_sel\n");

  i2 = GUI_List_select (w_list, 0);
  i1 = i2 - 1;
  GUI_List_clear (w_list, i1, i2);


}


/*===================================================================== */
  void list_del_all (GtkWidget *widget, void* data) {
/*=================
*/

  printf("list_del_all\n");

  GUI_List_clear (w_list, 0, 9999);

}



/*===================================================================== */
  int f_menu_M20 (GtkWidget *parent, void *data) {
/*==============
*/
  printf("M21 %d\n",(int)data);

  if((int)data == 3) {
    gtk_exit (1);
  }
  return 0;
}



/*===================================================================== */
  int f_menu_M21 (GtkWidget *parent, void *data) {
/*==============
*/
  printf("M22 %d\n",(int)data);
  /* gtk_exit (1); */
  return 0;
}


/* --------------- eof ------------------------- */
