/*   Vorversion von ut-Funktionen.


fuer GUI_PathSelectDialog


..............................................................
Das Startverzeichnis  actDir kommt via Paramter herein;
 das gewaehlte Dir. wird via stdout ausgegeben.

es gibt ein aktives Verzeichnis actDir.
Am Beginn eine Liste aller verfuegbaren RootPfade machen;
 diese dann auflisten.
 Wenn actDir sich im momentanen RootDir befindet, eine Liste dieses
 Verzeichnisses einblenden; sonst nur das RootDir.




Alle darzustellen Pfade in eine Texttabelle (psd_total), mit \0 terminiert.
  Mit GUI_PathSelectDialog_write () darstellen,
  beim exit selektierten text extrahieren.









============================================================*/






#ifdef _MSC_VER
#include <windows.h>
#endif


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <gtk/gtk.h>

#include "../ut/ut_txt.h"         // fnam_del_s

#include "../gtk/ut_gtk.h"

#include "../gr/ut_UI.h"          // UI_FuncOK




static GtkWidget *psd_w_win, *psd_w_lst, *psd_w_inf;


// static char psd_roots[1024];
// static char psd_total[10000];
static char *psd_roots;
static char *psd_total;
static long *psd_totSiz;
#define      psd_rootSiz 1024





//==========================================================================
  int GUI_PathSelectDialog_sel (GtkWidget *parent, void *data) {
//=====================================================================
// den selektierten Text kann man nicht auslesen;
// sel. Zeile an GUI_PathSelectDialog_CB melden

  int   i1;

  printf("GUI_PathSelectDialog_sel\n");

  i1 = GUI_List_select (psd_w_lst, 0);
  printf("list1_sel %d\n",i1);

  if(i1 < 0) return 0;  // deselect .. Mist



  // Nummer der selektierten Zeile merken ..
  GUI_PathSelectDialog_CB ((void*)i1, (void*)UI_FuncUCB2);


  return 0;

}


//==========================================================================
  int GUI_PathSelectDialog_CB (GtkWidget *parent, void *data) {
//=====================================================================

  static void (*userFunc)();
  static int  iSel=-1;
  static char mode, actDir[128];

  int  idat, i1;
  char *p1, *p2, cbuf[256];

  printf("GUI_PathSelectDialog_CB %d\n",(int)data);

  idat = (int)data;







  switch(idat) {


    case UI_FuncKill:
      gtk_widget_destroy (psd_w_win);
      return 0;


    case UI_FuncOK:
      printf("FuncOK %d |%s|%c|\n",iSel,actDir,mode);
/*
        // es wurde zeile iSel selektiert; liefern.
        // get text of line Nr. iSel -> p1
        p1 = psd_total;
        for(i1=1; i1<iSel; ++i1) { p1 += strlen(p1) + 1; }
*/
      if(mode == 'w') {
        // check ob sel. path beschreibbar ist; 0=nein, 1=ja
        if(OS_dir_ck2(actDir) < 1) {
          sprintf(cbuf, " cannot write to path %s  !! ",actDir);
          GUI_DialogY (cbuf);
          return 0;
        }
      }
      (*userFunc) (actDir);  // call userfunction
      gtk_widget_destroy (psd_w_win);
      return 0;



    case UI_FuncCancel:
      (*userFunc) (NULL);
      gtk_widget_destroy (psd_w_win);
      return 0;


    case UI_FuncUCB1:  // die Userfunc merken ..
      userFunc = parent;
      return 0;


    case UI_FuncUCB2:  // die selektierte Zeile merken ..
      iSel = (int)parent;
      printf("   %d sel\n",iSel);
      p1 = psd_total;
      for(i1=1; i1<iSel; ++i1) { 
        // printf(" %d=|%s|\n",i1,p1);
        p1 += strlen(p1) + 1;
      }
      printf(" sel:|%s| act:|%s|\n",p1,actDir);


      // sind die letzten 2 chars "..": einen Level runter.
      if(p1[strlen(p1)-1] != '.') goto L_weiter0;
      if(p1[strlen(p1)-2] != '.') goto L_weiter0;
      p1[strlen(p1)-3] = '\0';  // remove "/.."
      p2=strrchr(p1, fnam_del);
      if(p2) *p2 =  '\0';  // remove "/pfad"
      printf(" go down |%s|\n",p1);
      goto L_weiter0;

      L_weiter0:
      strcpy(actDir, p1);
      // Liste neu befuellen
      GUI_PathSelectDialog_write (1, actDir, NULL);
      return 0;


    case UI_FuncUCB3:  // actDir merken ..
      strcpy(actDir, (char*)parent);
      return 0;


    case UI_FuncUCB4:  // mode merken ..
      mode = (char*)parent;
      return 0;




    default:;
  }


      gtk_widget_destroy (psd_w_win);
      psd_w_win=NULL;

  return 0;
}


//==========================================================================
  int GUI_PathSelectDialog_write (int mode, char* actDir, char *txtIn) {
//==========================================================================
// die gesamte Liste schreiben

  static char appNam[64];


  int    i1, i2, ii, iAnz;
  char   *p1, *p2, *p3, cbuf[256];


  printf("=======================================================\n");
  printf("GUI_PathSelectDialog_write |%s|\n",actDir);


  if(mode == 0) {
    strcpy(appNam, txtIn);
    // return 0;
  }


  // zuerst Liste psd_total generieren;
  psd_total[0] = '\0';

  i1 = 0;
  p1 = psd_roots;

  i2 = 0;
  p2 = psd_total;

  // loop tru drives ..
  L_nxt_drv1:
    // printf(" l1:|%s| %d\n",p1,strlen(p1));


    // check ob psd_roots beschreibbar ist
    // irc=0:CD-Rom, 1=Diskette, 2=normal.
    if(OS_dir_ck1(p1) < 2) goto L_weiter1;


    // add new (not active) drive to List
    ii = strlen(p1);
    // if(*p1 != actDir[0]) {
    if(strncmp(actDir, p1, ii)) {
      i2 += strlen(p1) + 1;
      if(i2 >= psd_totSiz) goto L_err1;
      strcat(p2, p1);
      p2 = &psd_total[i2];
      *p2 =  '\0';
      goto L_weiter1;
    }



    // das ist der active drive;
    // add "actDir/.." to list (goDown - label)
    // aber nur wenn es der second level ist
    // if(strlen(actDir) > 3) {
    iAnz = 0;
    if(strcmp(actDir, p1)) {
      strcpy(cbuf, actDir);
      strcat(cbuf, fnam_del_s);  // add "\\"
      strcat(cbuf, "..");
      i2 += strlen(cbuf) + 1;
      if(i2 >= psd_totSiz) goto L_err1;
      strcat(p2, cbuf);
      p2 = &psd_total[i2];
      *p2 =  '\0';
      ++iAnz;
    }


    // scan directory actDir ..
    ii = 0;
    strcpy(cbuf, actDir);

    L_nxt_fil:
    OS_dir_scan_ (cbuf, &ii);
    if(ii < 0) {
      // wenn im ganzen Verzeichnis kein Dir, zumindest root raus.
      if(iAnz < 1) {
        i2 += strlen(p1) + 1;
        if(i2 >= psd_totSiz) goto L_err1;
        strcat(p2, p1);
        p2 = &psd_total[i2];
        *p2 =  '\0';
      }
      goto L_weiter1;
    }

    // normal File or directory ?
    if(OS_check_isDir(cbuf) != 0) goto L_nxt_fil;
    if(OS_dir_ck1(cbuf) < 2) goto L_nxt_fil;

    // add new line to list
    i2 += strlen(cbuf) + 1;
    if(i2 >= psd_totSiz) goto L_err1;
    strcat(p2, cbuf);
    p2 = &psd_total[i2];
    *p2 =  '\0';
    ++iAnz;
    goto L_nxt_fil;



    L_weiter1:  // goto next psd_roots
    // printf("......... next psd_roots |%s| %d\n",p1,i1);
    i1 += strlen(p1) + 1;
    p1 = &psd_roots[i1];
    if(strlen(p1) > 0) goto L_nxt_drv1;







  //-------------------------------------------------------------------
  // gesamte Liste loeschen
  GUI_List_clear (psd_w_lst, 0, 9999);

  // nun Liste ausgeben
  // loop tru list of drives ..
  i1 = 0;

  L_nxt_drv2:
    p1 = &psd_total[i1];
    // printf(" l2:|%s|\n",p1);

    // check ob psd_roots beschreibbar ist
    // irc=0:CD-Rom, 1=Diskette, 2=normal.
    if(OS_dir_ck1(p1) < 2) goto L_weiter2;



    GUI_List_add (psd_w_lst, p1);


    L_weiter2:
    i1 += strlen(p1) + 1;
    if(strlen(p1) > 0) goto L_nxt_drv2;
  //--------------------------------------------------------------------------



  strcpy(cbuf, actDir);
  strcat(cbuf, fnam_del_s);  // add "\\"
  strcat(cbuf, appNam);
  gtk_label_set (GTK_LABEL (psd_w_inf), cbuf);


  return 0;
 

  L_err1:
  TX_Error("GUI_PathSelectDialog_write E001");
  return -1;
}



//==========================================================================
  int GUI_PathSelectDialog (char mode, void* memspc, int memsiz,
                            char *txt1,char *txt2,char *txt3,void *funcnam) {
//==========================================================================
// mode   'r' = rea; 'w'=write
// txt1 = promptText
// txt2 = startDirectory
// txt3 = applicationName


  int    i1;
  static GtkWidget *box0, *box1, *w1, *w2, *w3;


  if(memsiz < 2000) goto L_err1;


  // psd_roots-Liste befuellen
  psd_roots = memspc;   // vorn im memseg
  if(OS_dir_list_ (psd_roots, psd_rootSiz) < 0) goto L_err1;



  psd_total = &psd_roots[psd_rootSiz];
  psd_totSiz = memsiz - psd_rootSiz - 1;


  if(psd_w_win != NULL) {
    GUI_PathSelectDialog_CB (NULL, (void*)UI_FuncKill);
  }


      psd_w_win=GUI_Window("Select Directory",GUI_PathSelectDialog_CB,
                               (void*)UI_FuncCancel,0);

      gtk_widget_set_uposition (psd_w_win, 0, 0);
      gtk_widget_set_usize (psd_w_win, 300, 600);


      box0 = GUI_Vbox (psd_w_win, 0);

      GUI_Label (box0, txt1, 10);


  // Liste
  // psd_w_lst = GUI_List (box0, GUI_PathSelectDialog_CB, (void*)UI_FuncUCB1);
  psd_w_lst = GUI_List (box0, GUI_PathSelectDialog_sel, NULL);


  // funcnam merken
  GUI_PathSelectDialog_CB (funcnam, (void*)UI_FuncUCB1);

  // actDir merken
  GUI_PathSelectDialog_CB ((void*)txt2, (void*)UI_FuncUCB3);

  // mode merken
  GUI_PathSelectDialog_CB ((void*)mode, (void*)UI_FuncUCB4);



  w1 = GUI_Hbox (box0, -1);
  w2 = GUI_Frame (w1, NULL, 6);
  w3 = GUI_Hbox (w2, 6);
  psd_w_inf = GUI_Label (w3, "", 0);
  // gtk_misc_set_alignment (GTK_MISC (psd_w_inf), 0., 0.5);



  box1 = GUI_Hbox (box0, -1);
  GUI_Butt (box1, "OK", GUI_PathSelectDialog_CB, (void*)UI_FuncOK, 5);
  GUI_Butt (box1, "Abbrechen",GUI_PathSelectDialog_CB, (void*)UI_FuncCancel, 5);


  gtk_widget_show (psd_w_win);
  // break;


  // appNam merken & Liste befuellen
  GUI_PathSelectDialog_write (0, txt2, txt3);




  return 0;


  L_err1:
    TX_Error("GUI_PathSelectDialog E001");
    return -1;

}

//========================= EOF ====================================
