/*   Notebook-Tests.
make -f tst_gtk6.mak&&./tst6.exe

============================================================*/





#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <fcntl.h>           // O_RDONLY
#include <sys/types.h>       // f. S_ISDIR
#include <sys/stat.h>        /* f. mkdir */



#include <gtk/gtk.h>

#include "../ut/ut_txt.h"         // fnam_del_s

#include "../gtk/ut_gtk.h"

#include "../gr/ut_UI.h"          // UI_FuncOK



const double UT_VAL_MAX  =  9999999999999.999;   // ex ut_geo.c

#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];      // wird von ut_txfil.c benutzt !!!!!




//================================================================
  int my_Notebook_CB (int pgNr) {
//================================================================
// callback of switch-notebook-page

  printf("my_Notebook_CB %d\n",pgNr);

  return;

}


/*===================================================================== */
  int UI_exit (GtkWidget *parent, void *data) {
/*===================================================================== */
// exit

  printf("UI_exit\n");

  exit(0);
  return 0;

}


//==========================================================================
  int main (int argc, char *argv[]) {
//==========================================================================


  GtkWidget *wwin, *wnb, *wch1, *wch2;

  GUI_Init ("");


  wwin = GUI_Window ("Hallo", UI_exit, NULL, 0);

  wnb = GUI_Notebook__ (wwin, my_Notebook_CB);


  // widgets page 1
  wch1 = GUI_Notebook_add (wnb, "NB-Func 1");
  GUI_Label (wch1, "Seite 1", 0);


  // widgets page 2
  wch2 = GUI_Notebook_add (wnb, "NB-Func 2");
  GUI_Label (wch2, "Seite 2", 0);



  gtk_widget_show (wwin);
  gtk_main ();

  return 0;
}





/*
//==========================================================================
  int main (int argc, char *argv[]) {
//==========================================================================

  GtkWidget *wwin, *wbox, *wnb, *wch1, *wch2, *wtmp1;

  gtk_disable_setlocale ();  // sonst Beistrich statt Decimalpunkt !! (LC_ALL)

  gtk_init (&argc, &argv);

  wwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_signal_connect (GTK_OBJECT(wwin), "destroy",
                     (GtkSignalFunc)gtk_exit, NULL);


  //----------------------------------------------------------------
  // define content of page 1
  wch1 = gtk_label_new (" Notebook Seite 1");
  gtk_widget_show (wch1);


  //----------------------------------------------------------------
  // define content of page 2
  wch2 = gtk_label_new (" Notebook Seite 2");
  gtk_widget_show (wch2);


  //----------------------------------------------------------------
  wnb = gtk_notebook_new ();
  gtk_container_add(GTK_CONTAINER(wwin),  wnb);
  gtk_widget_show (wnb);

  gtk_signal_connect (GTK_OBJECT(wnb), "switch-page",
                      (GtkSignalFunc)GUI_Notebook_CB, NULL);
                      // GTK_SIGNAL_FUNC(GUI_Notebook_CB), (gpointer)wnb);


  wtmp1 = gtk_label_new ("page 1");    // label for notebook-page
  gtk_notebook_append_page (GTK_NOTEBOOK(wnb), wch1, wtmp1);


  wtmp1 = gtk_label_new ("page 2");    // label for notebook-page
  gtk_notebook_append_page (GTK_NOTEBOOK(wnb), wch2, wtmp1);



  //----------------------------------------------------------------
  gtk_widget_show (wwin);
  gtk_widget_set_usize (GTK_WIDGET(wwin), 200,200);
  gtk_main ();


  return 0;
}
*/

//========================= EOF ====================================
