# include-File to link gCAD3D-Plugins (DLLs)
# Alle ausfuehren:
# find . -name "xa_*.mak" -exec make -f {} \;
# Alle Files listen:
# find . -name "xa_*.mak" -exec make srclst -f {} \;


# Debug 1=Debug-ON
#       2=Distribute;DebugOFF
DEB   = 1




# Version GTK1:
# GUICP  = `gtk-config --cflags` -DGTK1

# Version GTK2:
  GUICP  = `pkg-config --cflags gtkgl-2.0` -DGTK2

# GLBOBJ = GL_glarea
# GUILK  = `pkg-config --libs gtk+-2.0`\
#          /usr/lib/libgtkgl-2.0.a\
#           -L/usr/X11R6/lib -lGLU -lGL


OUTDIR = ../bin/

# options debug:
ifeq "$(DEB)" "1"
 CXLinux = -fPIC -pg -ggdb -D_INTEL $(GUICP)
 LKFLG = -lm -shared -Wl,-soname,$(DLLNAM) -pg -ggdb


# options distri:
else
 CXLinux = -fPIC -pg -ggdb -D_INTEL $(GUICP)
 LKFLG = -lm -shared -Wl,-soname,$(DLLNAM)
endif



SRC1 = ${OBJ1:.o=.c}



default:	$(OBJ1)
	@echo ====================== Link ======================
	@echo Make $?
	$(CC) -o $(OUTDIR)$(DLLNAM).so $(OBJ1) $(LKFLG)
ifeq "$(DEB)" "2"
	strip $(OUTDIR)$(DLLNAM).so
endif
#	if test `basename $$PWD` != "xa"; then mv $(DLLNAM).so ../xa/.; fi



# Ausgabe der ObjectFileList (f xa_find ..)
objlst:
	@echo $(OBJ1)


# vi holt damit seine sourcefileliste
srclst:
	@echo $(SRC1)


#StartFunc:
#	make "OPSYS=`uname -s`" -f $(DLLNAM).mak make


# ACHTUNG: case of filename muss genau stimmen, else xx.o Datei nicht gefunden
.c.o:
	@echo ================= Comp $@ ========================
	@echo $(@D) $(@F) $@
#	$(CC) -c $(CX$(OPSYS)) $(GUICP) $<
	$(CC) -c $(CXLinux) $<
	if test $(@D) != "."; then mv $(@F) $@; fi
	etags -f $(notdir $*).tag $<
# das Tagfile ins aktive Dir moven
#	mv -f $(notdir $*).tag $(@D)/.


########################### EOF #######################
